package cn.ibizlab.humanresource.core.humanresource.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import com.alibaba.fastjson.JSONObject;
import org.springframework.cache.annotation.CacheEvict;

import cn.ibizlab.humanresource.core.humanresource.domain.HRResearch;
import cn.ibizlab.humanresource.core.humanresource.filter.HRResearchSearchContext;


import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[HRResearch] 服务对象接口
 */
public interface IHRResearchService extends IService<HRResearch>{

    boolean create(HRResearch et) ;
    void createBatch(List<HRResearch> list) ;
    boolean update(HRResearch et) ;
    void updateBatch(List<HRResearch> list) ;
    boolean remove(String key) ;
    void removeBatch(Collection<String> idList) ;
    HRResearch get(String key) ;
    HRResearch getDraft(HRResearch et) ;
    boolean checkKey(HRResearch et) ;
    boolean save(HRResearch et) ;
    void saveBatch(List<HRResearch> list) ;
    Page<HRResearch> searchDefault(HRResearchSearchContext context) ;
    List<HRResearch> selectByHremployeeid(String employeeid) ;
    void removeByHremployeeid(String employeeid) ;
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

    List<HRResearch> getHrresearchByIds(List<String> ids) ;
    List<HRResearch> getHrresearchByEntities(List<HRResearch> entities) ;
}


